<template>
  <div class="forgot-form">
    <img v-lazy="logo.ImagePath" class="forgot-form__logo" />
    <div class="forgot-form__content">
      <div class="forgot-form__text-container">
        <h3 class="forgot-form__title">
          {{ $t("reset_password_form_title") }}
        </h3>
        <p class="forgot-form__instruction">
          {{ $t("reset_password_form_instruction") }}
        </p>
      </div>
      <el-form
        ref="forgotPasswordFormRef"
        class="forgot-form__form"
        :model="forgotPasswordFormData"
        :rules="forgotPasswordFormRules"
        :validate-on-rule-change="false"
      >
        <el-form-item class="forgot-form__input" prop="Email">
          <el-input
            v-model="forgotPasswordFormData.Email"
            type="email"
            :placeholder="$t('email')"
            :disabled="isProcessing"
            class="ol-bg-light"
          ></el-input>
        </el-form-item>
        <el-form-item class="forgot-form__button-container">
          <el-button
            :disabled="forgotPasswordFormData.Email && isProcessing"
            class="flex items-center !font-bold w-full !px-5 !py-[10px] !text-base rounded-2xl btn forgot-for__reset-button"
            style
            @click="submitForm(forgotPasswordFormRef)"
            >{{ $t("reset") }}</el-button
          >
          <span class="forgot-form__bottom-action"
            ><span>{{ $t("reset_password_form_return_to") }}</span>
            <button @click.prevent="onLoginClick" class="text-[color:var(--selected)] underline cursor-pointer">{{ $t("capital_login") }}</button>
          </span>
        </el-form-item>
      </el-form>
    </div>
  </div>
</template>

<script setup lang="ts">
import { computed } from "vue";
import { store } from "@/store";
import themePropertyHelper from "@/utils/themePropertyHelper";
import { IThemePropertiesFromApi } from "@/models/companyThemePropertiesRespone";

const themeProperties = computed(
  () => store.state.companyThemePropertiesFromApi.ThemeProperties
);
const logo = computed(
  (): IThemePropertiesFromApi =>
    themePropertyHelper.getSingleThemeProperty(themeProperties.value, "logo")
);
const emit = defineEmits(["onSuccess", "onFailure", "onLoginClick"]);
const onSuccess = () => {
  emit("onSuccess");
};
const onFailure = () => {
  emit("onFailure");
};
const onLoginClick = () => {
  emit("onLoginClick");
};
const {
  isProcessing,
  forgotPasswordFormData,
  forgotPasswordFormRef,
  forgotPasswordFormRules,
  submitForm,
} = useResetPassword({ onSuccess, onFailure });
</script>

<style scoped lang="scss">
.forgot-form {
  position: relative;
  display: flex;
  flex-direction: column;
  align-items: center;
  padding: 0px 40px 40px;
  gap: 12px;
  color: var(--text5, #fff);
}

.forgot-form__logo {
  width: 96px;
  height: 32px;
  object-fit: contain;
}

.forgot-form__text-container {
  display: flex;
  flex-direction: column;
  align-items: center;
  padding: 0px;
  gap: 20px;
  text-align: center;
}

.forgot-form__content {
  display: flex;
  flex-direction: column;
  align-items: center;
  padding: 0px;
  gap: 40px;
  max-width: 400px;
  width: 100%;
}

.forgot-form__title {
  font-style: normal;
  font-weight: 400;
  font-size: 32px;
  line-height: 37.5px;
  color: var(--text5);
  hyphens: auto;
  word-break: break-word;
}

.forgot-form__instruction {
  color: var(--text5);
  font-style: normal;
  font-weight: 400;
  font-size: 16px;
  line-height: 18.75px;
  text-align: center;
  hyphens: auto;
  word-break: break-word;
}

.forgot-form__form {
  display: flex;
  flex-direction: column;
  align-items: center;
  gap: 40px;
  width: 100%;
  border-radius: 8px;

  .el-form-item {
    margin-bottom: 0;
    max-width: 350px;
    width: 100%;
  }
}

.forgot-form__button-container {
  :deep(.el-form-item__content) {
    display: flex;
    flex-direction: column;
    align-items: center;
    padding: 0px;
    gap: 8px;
    width: 100%;
  }

  .forgot-for__reset-button {
    width: 100%;
    height: 40px;
    background: var(--primary) !important;
    color: var(--textBtn);
    &:disabled {
      opacity: 0.5;
    }
  }
}

.forgot-form__bottom-action {
  display: inline-flex;
  width: 100%;
  justify-content: center;
  text-align: center;
  font-style: normal;
  font-weight: 400;
  font-size: 16px;
  line-height: 19px;
  color: var(--textBtn);

  span {
    color: var(--text5, #fff);
  }

  button {
    display: inline-block;
    width: fit-content;
    margin-left: 0.25rem;
    width: unset;
    height: unset;
  }
}
.forgot-form {
  --bg-base-color: var(--background5);
  --bg-opacity: 5%;
  :deep(.el-input) {
    border-radius: 4px;
    color: var(--text5, #fff);
    --el-input-text-color: var(--text5, #fff);
  }
  :deep(.is-error .el-input) {
    border-color: var(--failure);
  }
  :deep(.el-input__inner) {
    height: 39px;
    width: 100%;
  }
  :deep(.el-form-item__error) {
    padding-top: 4px;
    margin-left: unset;
  }
  :deep(.reset-password-notification) {
    position: absolute;
    top: unset !important;
    bottom: 115%;
    left: 50%;
    transform: translateX(-50%);
    max-width: 360px;
    width: 100%;
    --el-notification-padding: 16px;
    background: var(--background5);
    color: var(--text5);
    --el-notification-content-color: var(--text5);
    border-radius: 8px;
    align-items: center;
    border: none;
  }
  :deep(.reset-password-notification .el-notification__icon) svg {
    width: 24px;
    height: 24px;
  }
  :deep(.reset-password-notification .el-notification__group) {
    --el-notification-group-margin-left: 8px;
    --el-notification-group-margin-right: 0;
  }
  :deep(.el-form-item__content) {
    justify-content: flex-start !important;
    margin-top: 0 !important;
  }
  :deep(.el-input__inner::placeholder) {
    color: var(--text5);
    opacity: 0.5;
  }
}

[layout="china"] {
  .forgot-form {
    :deep(.el-input) {
      border: 1px solid var(--border);
    }
    :deep(.is-error .el-input) {
      border-color: var(--failure);
    }
  }
}
</style>
